Subject: [Roll] [RPL] Grounded flag

From: "Julien Abeille (jabeille)" <[email-masked]>
Date: Wed, 15 Jul 2009 16:31:39 +0200

Hi all,
 
- could you clarify how the Grounded flag in DIO interferes with the
router lifetime in RAs? 
a router with a default route usually sets non 0 router lifetime in RA
to indicate so, and sets it to 0 if does not want to be considered a
default router. Hence the meaning of the grounded flag is similar to the
router lifetime being 0 or not.
 
If the idea is to force nodes that receives a RA with router lifetime
non 0 not to configure the sender as a default router (to allow nodes to
choose which default router they want using parent selection), then it
could be precised that routers should set router lifetime to 0 even if
they have a default route.
 
- in section 5.1.1.5:
"Note that Destination Prefixes specified in this manner inherit the
   Router Lifetime of their parent RA"
if the router has no default route, router lifetime is 0. Hence the
prefix will not be added, or will be deleted, simply because the sender
has no default route.
- what happens if a node receives a DIO with G flag not set and no
destination prefix? what is the meaning of such a message?
 
Best,
Julien

---

From: "Julien Abeille (jabeille)" <[email-masked]>
Date: Mon, 20 Jul 2009 11:00:54 +0200

reseding
Julien

________________________________

	From: [email-masked] [mailto:[email-masked]] On
Behalf Of Julien Abeille (jabeille)
	Sent: mercredi 15 juillet 2009 16:32
	To: [email-masked]
	Subject: [Roll] [RPL] Grounded flag

	Hi all,
	 
	- could you clarify how the Grounded flag in DIO interferes with
the router lifetime in RAs? 
	a router with a default route usually sets non 0 router lifetime
in RA to indicate so, and sets it to 0 if does not want to be considered
a default router. Hence the meaning of the grounded flag is similar to
the router lifetime being 0 or not.
	 
	If the idea is to force nodes that receives a RA with router
lifetime non 0 not to configure the sender as a default router (to allow
nodes to choose which default router they want using parent selection),
then it could be precised that routers should set router lifetime to 0
even if they have a default route.
	 
	- in section 5.1.1.5:
	
	"Note that Destination Prefixes specified in this manner inherit
the
	   Router Lifetime of their parent RA"
	if the router has no default route, router lifetime is 0. Hence
the prefix will not be added, or will be deleted, simply because the
sender has no default route.
	- what happens if a node receives a DIO with G flag not set and
no destination prefix? what is the meaning of such a message?
	 
	Best,
	Julien

---

From: Tim Winter <[email-masked]>
Date: Tue, 21 Jul 2009 22:34:24 -0400

Hi Julien,

Thanks for your comments, I do think you have caught something here that we
need to refine further in the next revision.

Julien Abeille (jabeille) wrote:
> reseding
> Julien
> 
>     ------------------------------------------------------------------------
>     *From:* [email-masked] [mailto:[email-masked]] *On
>     Behalf Of *Julien Abeille (jabeille)
>     *Sent:* mercredi 15 juillet 2009 16:32
>     *To:* [email-masked]
>     *Subject:* [Roll] [RPL] Grounded flag
> 
>     Hi all,
>      
>     a router with a default route usually sets non 0 router lifetime in
>     RA to indicate so, and sets it to 0 if does not want to be
>     considered a default router. Hence the meaning of the grounded flag
>     is similar to the router lifetime being 0 or not.
Yes, Alex had made a similar observation as well.  But see below:

>     lifetime non 0 not to configure the sender as a default router (to
>     allow nodes to choose which default router they want using parent
>     selection), then it could be precised that routers should set router
>     lifetime to 0 even if they have a default route.
>      
>     - in section 5.1.1.5:
> 
>     if the router has no default route, router lifetime is 0. Hence the prefix will not be added, or will be deleted, simply because the sender has no default route.
Based on these and other comments, I think we may need to open up the
definition of Grounded, and we should not overload the router lifetime as in
the current draft-
There may be application scenarios where a node acts as a MP2P sink but does
not want to offer the default route.  For example, a node may be some sort
of standalone controller that only has an LLN interface and does not /
cannot offer the default route.  Such a node ought to be grounded for the
purposes of DAG discovery, because of its application role, and ought to
offer some meaningful prefix to the application (note however that
application service discovery is outside the scope of RPL).  The lifetime of
such prefixes then ought to be defined independently of the router lifetime
in the RA.  Another example that has been extended on this list is the case
where an electric meter may participate in both a utility network and a home
network, and may want to offer a prefix for the home network to route
certain traffic directly into the utility network, but does not want to
provide a default route for the home network (the home network must find
another default route through the homeowners ISP for all other traffic).

So the determination of Grounded (MP2P sink) may be the result of
application provisioning (via configuration API), and does not necessarily
imply the default route, and the Destination Prefix suboption ought to be
augmented with a lifetime.

How does this sound?

>     destination prefix? what is the meaning of such a message?
This would most typically be a DIO indicating a floating DAG- generally a
transient condition.  The members of the floating DAG will be seeking a
grounded DAG to re-attach to.  I dont know of any example that would suggest
a floating DAG should be advertising any other destination prefix.

>      
>     Best,
>     Julien
> 
> 
> ------------------------------------------------------------------------
> 
> _______________________________________________
> Roll mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/roll

Regards,

-Tim

---

From: "Julien Abeille (jabeille)" <[email-masked]>
Date: Wed, 22 Jul 2009 09:42:34 +0200

Hi Tim,

Thanks for your answer. 

The meaning you propose is not that clear to me. Taking the example of
the DAG root which is an application controller: saying that calling it
a grounded router to allow nodes to connect to this DAG
However, the examples you state (smart meter...) make perfect sense. I
feel that the Destination prefix suboption allows these application
examples to work. (I have no strong opinion yet on whether a separate
lifetime should be added to this suboption)

I would prefer RPL not to contain application level concepts, but still
allow application scenarios we have in mind, at routing level. I feel
the destination prefix suboption does this.

Best,
Julien

> -----Original Message-----
> From: Tim Winter [mailto:[email-masked]] 
> Sent: mercredi 22 juillet 2009 04:34
> To: Julien Abeille (jabeille)
> Cc: ROLL WG
> Subject: Re: [Roll] [RPL] Grounded flag
> 
> Hi Julien,
> 
> Thanks for your comments, I do think you have caught 
> something here that we need to refine further in the next revision.
> 
> >     if the router has no default route, router lifetime is 
> 0. Hence the prefix will not be added, or will be deleted, 
> simply because the sender has no default route.
I agree with you, a separate lifetime makes sense

> Based on these and other comments, I think we may need to 
> open up the definition of Grounded, and we should not 
> overload the router lifetime as in the current draft- There 
> may be application scenarios where a node acts as a MP2P sink 
> but does not want to offer the default route.  For example, a 
> node may be some sort of standalone controller that only has 
> an LLN interface and does not / cannot offer the default 
> route.  Such a node ought to be grounded for the purposes of 
> DAG discovery, because of its application role, and ought to 
> offer some meaningful prefix to the application (note however 
> that application service discovery is outside the scope of 
> RPL). 
I have the feeling that calling such a node "grounded" is useful only
for parent/DAG selection. However, parent/DAG selection can be
influenced in RPL by other means already (preference...) hence I would
avoid putting an application layer concept in RPL. 

what we want to achieve in this example (that nodes attach to this
controller's DAG) can be done with the current draft. You can e.g. set a
very high preference and design the parent seletion algorithm to check
mostly the preference. Hence without having application logic in the
routing layer, we enable people to deploy a network that make their
applications work. 

I would keep the grounded concept as is but remove the grounded flag,
and as you say add a separate lifetime for destination prefix.

Best,
Julien

> The lifetime of such prefixes then ought to be defined 
> independently of the router lifetime in the RA.  Another 

> example that has been extended on this list is the case where 
> an electric meter may participate in both a utility network 
> and a home network, and may want to offer a prefix for the 
> home network to route certain traffic directly into the 
> utility network, but does not want to provide a default route 
> for the home network (the home network must find another 
> default route through the homeowners ISP for all other traffic).
> 
> So the determination of Grounded (MP2P sink) may be the 
> result of application provisioning (via configuration API), 
> and does not necessarily imply the default route, and the 
> Destination Prefix suboption ought to be augmented with a lifetime.
> 
> How does this sound?
> 
> > 
> This would most typically be a DIO indicating a floating DAG- 
> generally a transient condition.  The members of the floating 
> DAG will be seeking a grounded DAG to re-attach to.  I dont 
> know of any example that would suggest a floating DAG should 
> be advertising any other destination prefix.
> 
> >      
> >     Best,
> >     Julien
> > 
> > 
> >

---

From: Alexandru Petrescu <[email-masked]>
Date: Wed, 22 Jul 2009 11:20:11 +0200

Tim Winter a écrit :
> Hi Julien,
> 
> Thanks for your comments, I do think you have caught something here
> that we need to refine further in the next revision.
> 
>> reseding Julien
>> Behalf Of *Julien Abeille (jabeille) *Sent:* mercredi 15 juillet
>> 2009 16:32 *To:* [email-masked] *Subject:* [Roll] [RPL] Grounded
>> flag
>> 
>> Hi all,
>> 
>> the router lifetime in RAs? a router with a default route usually
>> sets non 0 router lifetime in RA to indicate so, and sets it to 0
>> if does not want to be considered a default router. Hence the
>> meaning of the grounded flag is similar to the router lifetime
>> being 0 or not.
>> selection), then it could be precised that routers should set
>> router lifetime to 0 even if they have a default route.
>> 
>> - in section 5.1.1.5:
>> 
>> the Router Lifetime of their parent RA"
>> 
>> prefix will not be added, or will be deleted, simply because the
>  definition of Grounded, and we should not overload the router
> lifetime as in the current draft- There may be application scenarios
> where a node acts as a MP2P sink but does not want to offer the
> default route.  For example, a node may be some sort of standalone
> controller that only has an LLN interface and does not / cannot offer
> the default route.  Such a node ought to be grounded for the purposes
> of DAG discovery, because of its application role, and ought to offer
> some meaningful prefix to the application (note however that 
> application service discovery is outside the scope of RPL).  The
> lifetime of such prefixes then ought to be defined independently of
> the router lifetime in the RA.  Another example that has been
> extended on this list is the case where an electric meter may
> participate in both a utility network and a home network, and may
> want to offer a prefix for the home network to route certain traffic
> directly into the utility network, but does not want to provide a
> default route for the home network (the home network must find 
> application provisioning (via configuration API), and does not
> necessarily imply the default route, and the Destination Prefix
> suboption ought to be augmented with a lifetime.
> 
> How does this sound?

This explanation sounds good to me, and I agree with a separation of a
'sink' from being the default route.

I would also verify later that any notion of default route introduced by
RPL does not contradict the existing notion of default route in the RA
(lifetime 0), e.g. make sure when both are present and a non-RPL machine
receives it makes the right interpretation, and similar.

Alex

> generally a transient condition.  The members of the floating DAG
> will be seeking a grounded DAG to re-attach to.  I dont know of any
> example that would suggest a floating DAG should be advertising any
> other destination prefix.
> 
>> 
>> Best, Julien
>> 
>> 
>> _______________________________________________ Roll mailing list 
>> [email-masked] https://www.ietf.org/mailman/listinfo/roll
> 
> 
> Regards,
> 
> -Tim _______________________________________________ Roll mailing
> list [email-masked] https://www.ietf.org/mailman/listinfo/roll
>